# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

addMat <- function(m1, m2) {
    .Call(`_binspp_addMat`, m1, m2)
}

multMat <- function(m1, m2) {
    .Call(`_binspp_multMat`, m1, m2)
}

intalphaC <- function(z_beta, alpha, alphabet, Wpix) {
    .Call(`_binspp_intalphaC`, z_beta, alpha, alphabet, Wpix)
}

aozC <- function(z, alpha, alphabet, u) {
    .Call(`_binspp_aozC`, z, alpha, alphabet, u)
}

logpXCbetC <- function(Y, CC, z_alpha, z_omega, alpha, alphabet, omega, omegabet, AreaW, integral) {
    .Call(`_binspp_logpXCbetC`, Y, CC, z_alpha, z_omega, alpha, alphabet, omega, omegabet, AreaW, integral)
}

KumulaVsechC <- function(CC, z_alpha, z_omega, alpha, alphabet, omega, omegabet, x_left, x_right, y_bottom, y_top) {
    .Call(`_binspp_KumulaVsechC`, CC, z_alpha, z_omega, alpha, alphabet, omega, omegabet, x_left, x_right, y_bottom, y_top)
}

PrioralphaC <- function(a, Prior_alpha_mean, Prior_alpha_SD) {
    .Call(`_binspp_PrioralphaC`, a, Prior_alpha_mean, Prior_alpha_SD)
}

PrioromegaC <- function(o, Prior_omega_mean, Prior_omega_SD) {
    .Call(`_binspp_PrioromegaC`, o, Prior_omega_mean, Prior_omega_SD)
}

PrioralphabetC <- function(a, Prior_alphavec_SD) {
    .Call(`_binspp_PrioralphabetC`, a, Prior_alphavec_SD)
}

PrioromegabetC <- function(o, Prior_omegavec_SD) {
    .Call(`_binspp_PrioromegabetC`, o, Prior_omegavec_SD)
}

StepbetC <- function(kappa, z_alpha, z_omega, alpha, salpha, alphabet, salphabet, omega, somega, omegabet, somegabet, Y, CC, logP, integral, integralrho, x_left, x_right, y_bottom, y_top, Wpix, AreaW, FScoef, Prior_alpha_mean, Prior_alpha_SD, Prior_omega_mean, Prior_omega_SD, Prior_alphavec_SD, Prior_omegavec_SD) {
    .Call(`_binspp_StepbetC`, kappa, z_alpha, z_omega, alpha, salpha, alphabet, salphabet, omega, somega, omegabet, somegabet, Y, CC, logP, integral, integralrho, x_left, x_right, y_bottom, y_top, Wpix, AreaW, FScoef, Prior_alpha_mean, Prior_alpha_SD, Prior_omega_mean, Prior_omega_SD, Prior_alphavec_SD, Prior_omegavec_SD)
}

row_add <- function(x, extraRow) {
    .Call(`_binspp_row_add`, x, extraRow)
}

rand_int <- function(min, max) {
    .Call(`_binspp_rand_int`, min, max)
}

StepMovePointC <- function(kappa, z_alpha, z_omega, alpha, alphabet, omega, omegabet, Y, CC, logP, integral, integralrho, x_left, x_right, y_bottom, y_top, AreaW, NewCenter) {
    .Call(`_binspp_StepMovePointC`, kappa, z_alpha, z_omega, alpha, alphabet, omega, omegabet, Y, CC, logP, integral, integralrho, x_left, x_right, y_bottom, y_top, AreaW, NewCenter)
}

logpXCbeta <- function(X, CC, alpha, omega, AreaW, integral) {
    .Call(`_binspp_logpXCbeta`, X, CC, alpha, omega, AreaW, integral)
}

#' @title Calculate parameters for Birth and Death Interaction likelihood functions.
#' @description Calculates r1 and r2, which serve as distance thresholds for Birth and Death Interaction likelihood functions.
#' @param theta A vector of theta1 and theta2.
#' @return A vector of r1 and r2.
#' @export
coeff <- function(theta) {
    .Call(`_binspp_coeff`, theta)
}

BirthInteractionLik <- function(xprop, CC, rho0sum, theta, r) {
    .Call(`_binspp_BirthInteractionLik`, xprop, CC, rho0sum, theta, r)
}

DeathInteractionLik <- function(xprop, Death, CC, rho0sum, theta, r) {
    .Call(`_binspp_DeathInteractionLik`, xprop, Death, CC, rho0sum, theta, r)
}

pCClik <- function(thetaprop, CC) {
    .Call(`_binspp_pCClik`, thetaprop, CC)
}

#' @title Evaluate unnormalized likelihood for auxiliary variable
#' @description Calculates the unnormalized likelihood for an auxiliary variable by evaluating pairwise interaction between points. The interaction thresholds are derived from the input theta vector.
#' @param thetaprop A vector of theta1 and theta2.
#' @param CC A coordinate matrix of points.
#' @return A list of the computed likelihood and a row vector of summed interaction between points.
#' @export
pCClik2 <- function(thetaprop, CC) {
    .Call(`_binspp_pCClik2`, thetaprop, CC)
}

logpCCtemp <- function(X, CC, alpha, omega, numratio, AreaW, integral) {
    .Call(`_binspp_logpCCtemp`, X, CC, alpha, omega, numratio, AreaW, integral)
}

dgenpois_cpp <- function(x, lambda, theta, log_ret) {
    .Call(`_binspp_dgenpois_cpp`, x, lambda, theta, log_ret)
}

dgp_comp_cpp <- function(lambda, theta) {
    .Call(`_binspp_dgp_comp_cpp`, lambda, theta)
}

dgenpoisbin_cpp <- function(x, lambda, theta, mu, dgp) {
    .Call(`_binspp_dgenpoisbin_cpp`, x, lambda, theta, mu, dgp)
}

intfun_cols_cpp <- function(c, omega, xr, yr) {
    .Call(`_binspp_intfun_cols_cpp`, c, omega, xr, yr)
}

intfun_cpp <- function(c, omega, xr, yr) {
    .Call(`_binspp_intfun_cpp`, c, omega, xr, yr)
}

r_omega_cpp <- function(ostar, omega, X, C, lambda, theta, dgp, a_omega, b_omega) {
    .Call(`_binspp_r_omega_cpp`, ostar, omega, X, C, lambda, theta, dgp, a_omega, b_omega)
}

r_lt_cpp <- function(lstar, tstar, lambda, theta, dl, X, C, omega, dgp, dgpstar, l_lambda, u_lambda, a_theta, b_theta) {
    .Call(`_binspp_r_lt_cpp`, lstar, tstar, lambda, theta, dl, X, C, omega, dgp, dgpstar, l_lambda, u_lambda, a_theta, b_theta)
}

r_kappa_cpp <- function(kstar, kappa, m, win_size, a_kappa, b_kappa) {
    .Call(`_binspp_r_kappa_cpp`, kstar, kappa, m, win_size, a_kappa, b_kappa)
}

update_omega <- function(omega, somega, X, C, lambda, theta, dgp, a_omega, b_omega) {
    .Call(`_binspp_update_omega`, omega, somega, X, C, lambda, theta, dgp, a_omega, b_omega)
}

update_lt <- function(lambda, theta, stheta, dl, X, C, omega, dgp, l_lambda, u_lambda, a_theta, b_theta) {
    .Call(`_binspp_update_lt`, lambda, theta, stheta, dl, X, C, omega, dgp, l_lambda, u_lambda, a_theta, b_theta)
}

update_kappa <- function(kappa, skappa, m, win_size, a_kappa, b_kappa) {
    .Call(`_binspp_update_kappa`, kappa, skappa, m, win_size, a_kappa, b_kappa)
}

mcmc_lt <- function(lambda, theta, stheta, mus, dl, n, l_lambda, u_lambda, a_theta, b_theta) {
    .Call(`_binspp_mcmc_lt`, lambda, theta, stheta, mus, dl, n, l_lambda, u_lambda, a_theta, b_theta)
}

update_P_cpp <- function(X, C, omega, lambda, theta, mus, dgp, p_count) {
    .Call(`_binspp_update_P_cpp`, X, C, omega, lambda, theta, mus, dgp, p_count)
}

update_P_cpp_n <- function(X, C, omega, lambda, theta, mus, dgp, n_upd, p_count) {
    .Call(`_binspp_update_P_cpp_n`, X, C, omega, lambda, theta, mus, dgp, n_upd, p_count)
}

move_C_cpp <- function(X, C, omega, lambda, theta, sd_c, dgp, m_count) {
    .Call(`_binspp_move_C_cpp`, X, C, omega, lambda, theta, sd_c, dgp, m_count)
}

c_birth_cpp <- function(X, C, kappa, omega, lambda, theta, s_birth, dgp, b_count) {
    .Call(`_binspp_c_birth_cpp`, X, C, kappa, omega, lambda, theta, s_birth, dgp, b_count)
}

c_death_cpp <- function(X, C, kappa, omega, lambda, theta, s_birth, dgp, d_count) {
    .Call(`_binspp_c_death_cpp`, X, C, kappa, omega, lambda, theta, s_birth, dgp, d_count)
}

bdm <- function(X, C, ktmp, otmp, ltmp, ttmp, smove, sbirth, n_bdm, m_count, b_count, d_count) {
    invisible(.Call(`_binspp_bdm`, X, C, ktmp, otmp, ltmp, ttmp, smove, sbirth, n_bdm, m_count, b_count, d_count))
}

